﻿Module SewInfo

    Friend Sub FindArrayIndex(ByVal Xmm As Single, ByVal Ymm As Single)
        '
        Dim oldx, oldy As Single
        Dim Dist, MinDist As Double
        '
        MinDist = Double.MaxValue
        oldx = Single.MinValue
        '
        Dim Index As Int32
        For i As Int32 = 0 To DataArray1.GetNumEntries - 1
            Dim d As DataArray.DataSample = DataArray1.GetElement(i)
            If oldx > Single.MinValue Then
                'Dist = Distance_PointToSegment_2D(Xmm, Ymm, oldx, oldy, d.x, d.y)
                Dist = Dist2D(Xmm, Ymm, d.x, d.y)
                If Dist < MinDist Then
                    MinDist = Dist
                    Index = i
                End If
            End If
            oldx = d.x
            oldy = d.y
        Next
        If MinDist < 1 Then
            If Index <> SelectedIndex Then
                SelectedIndex = Index
                UpdateImage = True
            End If
        End If
    End Sub



    Friend Function DecodeInfoFromIndex() As String
        If SelectedIndex < 1 Then Return ""
        '
        Dim d1 As DataArray.DataSample = DataArray1.GetElement(SelectedIndex - 1)
        Dim d2 As DataArray.DataSample = DataArray1.GetElement(SelectedIndex)
        '
        Dim angle1 As Single = 360 * (d1.z Mod 1)
        Dim angle2 As Single = 360 * (d2.z Mod 1)
        Dim up1 As Boolean = IsNeedleUp(angle1)
        Dim up2 As Boolean = IsNeedleUp(angle2)
        Dim dist As Double = Math.Sqrt((d2.x - d1.x) ^ 2 + (d2.y - d1.y) ^ 2)
        Dim time As Long = d2.t
        Dim dt As Long = d2.t - d1.t
        '
        Dim s As String
        s = " Angles = "
        s = s + (angle1.ToString("0", GCI) + "°").PadRight(5)
        s = s + (angle2.ToString("0", GCI) + "°").PadRight(5)
        s += (" Pitch = " + dist.ToString("0", GCI) + " mm").PadRight(15)
        s += (" DeltaTime = " + dt.ToString("0", GCI) + " ms").PadRight(19)
        s += (" Time = " + time.ToString("0", GCI) + " ms").PadRight(16)
        s += (" Index = " + SelectedIndex.ToString("0", GCI))
        Return s
    End Function

End Module
